#!/usr/bin/perl -w

use strict;
$| = 1;

# Argument1:  local install path.  Defaults to /usr/local/nachos.
# Argument2:  system.  Defaults to uname -m + "-linux".

my $prefix = shift(@ARGV) || '/usr/local/nachos';
chomp(my $machine = `uname -m`);
my $arch = shift(@ARGV) || "$machine-linux";

my @tarcmds = ('tar -jxf binutils-2.14.tar.bz2', 'tar -zxf gcc-2.95.3.tar.gz');
foreach (@tarcmds)
{
    print $_, "\n";
    system(split(/ /, $_));
}

chdir('binutils-2.14');
my $bininst = "./configure --prefix=$prefix --host=$arch --target=decstation-ultrix";
print $bininst, ' && make', ' && make install', "\n";
(!(system(split(/ /, $bininst)) || system('make') || system('make install'))) || die 'A horrible, horrible death';

chdir('../gcc-2.95.3');
# Me screwing around
open(VERFILE, 'gcc/version.c');
my $verbody;
{
    local $/;
    $verbody = <VERFILE>;
}
close(VERFILE);
$verbody =~ s/release/Luke's h4x0r3d Linux->DEC MIPS cross-compiler/;

open(VERFILE, '>gcc/version.c');
print VERFILE $verbody;
close(VERFILE);

my $gccconfig = "./configure --host=$arch --target=decstation-ultrix --with-gnu-as --with-gnu-ld --prefix=$prefix --with-local-prefix=$prefix";
print $gccconfig, "\n";
(!system(split(/ /, $gccconfig))) || die 'GCC not configured.';

sleep(2);

# Redundancy because I can't remember which directory to fill up with this crap.
system('ar', 'rc', 'libgcc.a');
system('ar', 'rc', 'libgcc2.a');
system('ar', 'rc', 'gcc/libgcc.a');
system('ar', 'rc', 'gcc/libgcc2.a');

print "Luke h4x0r sk111z b3g1n!\n";
open(GCCMAKE, 'gcc/Makefile') || die "ERROR!";
my $makebody;
{
    local $/;
    $makebody = <GCCMAKE>;
}
close(GCCMAKE);
$makebody =~ s/^(LIBGCC1_TEST )/#$1/m;
$makebody =~ s/^(ENQUIRE )/#$1/m;
$makebody =~ s/(libgcc.a:).*?\n\n/$1 libgcc.a\n\techo "Luke is godlike!"\n\n/s;
$makebody =~ s/(libgcc2.a:).*?\n\n/$1 libgcc2.a\n\techo "Luke is L337!"\n\n/s;

open(GCCMAKE, '>gcc/Makefile');
print GCCMAKE $makebody;
close(GCCMAKE);

sleep(2);

print "make LANGUAGES=c && make install LANGUAGES=c\n";
(!(system('make LANGUAGES=c') || system('make install LANGUAGES=c'))) || die 'Another horrible, horrible death.';

print "Everything installed, now eliminating useless crap.";
chdir($prefix);
my @cmdslist = ('strip `find . -type f -perm -111 -print`',
		'rm -rf info man include share',
		'rm lib/lib*');
foreach (@cmdslist)
{
    print $_, "\n";
    system($_);
}

print "Guess what?  ALL DONE!  Enjoy Luke's h4x0r3d version of GCC 2.95.3, cross-compiled from Linux to DEC MIPS.\nComments?  Email lkosewsk\@uwaterloo.ca\n";
